import { LitElement } from 'lit';
import { EditorView } from '@codemirror/view';
import { SelectionRange, TransactionSpec } from '@codemirror/state';
import { RemoteCursor } from './remote-cursor';
export interface CodemirrorState {
    text: string;
    selection?: SelectionRange;
}
declare const CodemirrorMarkdown_base: typeof LitElement & import("@open-wc/dedupe-mixin").Constructor<import("@open-wc/scoped-elements/types/src/types").ScopedElementsHost>;
export declare class CodemirrorMarkdown extends CodemirrorMarkdown_base {
    editor: EditorView;
    _editorEl: HTMLElement;
    _state: CodemirrorState | undefined;
    set state(s: CodemirrorState);
    additionalCursors: Array<{
        name: string;
        position: number;
        color: string;
    }>;
    firstUpdated(): void;
    setState(state: CodemirrorState): void;
    dispatchChanges(changes: TransactionSpec): void;
    renderCursor(c: {
        position: number;
        name: string;
        color: string;
    }): import("lit-html").TemplateResult<1>;
    render(): import("lit-html").TemplateResult<1>;
    static styles: import("lit").CSSResult;
    static get scopedElements(): {
        'remote-cursor': typeof RemoteCursor;
    };
}
export {};
